/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.51 from the
 * contents of XS.xs. Do not edit this file, edit XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include "ppport.h"

#define ULID_LEN 16
#define ULID_TIME_LEN 6
#define ULID_RAND_LEN 10
#define RESULT_LEN 26

SV* encode_ulid(SV *strsv)
{
	unsigned long len;
	char *str = SvPVbyte(strsv, len);
	if (len != ULID_LEN) croak("invalid string length in encode_ulid: %d", len);

	char base32[] = "0123456789ABCDEFGHJKMNPQRSTVWXYZ";
	char result[RESULT_LEN];

	// This part will be replaced with a pregenerated base32 encoding for
	// ULIDs, which runs significantly faster. See gen/gen_streamlined_ulid.pl
	// script for details.

	// autogenerated:
	result[0] = base32[((str[0] & 0xe0)>>5)];
	result[1] = base32[((str[0] & 0x1f))];
	result[2] = base32[((str[1] & 0xf8)>>3)];
	result[3] = base32[((str[1] & 0x07)<<2) + ((str[2] & 0xc0)>>6)];
	result[4] = base32[((str[2] & 0x3e)>>1)];
	result[5] = base32[((str[2] & 0x01)<<4) + ((str[3] & 0xf0)>>4)];
	result[6] = base32[((str[3] & 0x0f)<<1) + ((str[4] & 0x80)>>7)];
	result[7] = base32[((str[4] & 0x7c)>>2)];
	result[8] = base32[((str[4] & 0x03)<<3) + ((str[5] & 0xe0)>>5)];
	result[9] = base32[((str[5] & 0x1f))];
	
	result[10] = base32[((str[6] & 0xf8)>>3)];
	result[11] = base32[((str[6] & 0x07)<<2) + ((str[7] & 0xc0)>>6)];
	result[12] = base32[((str[7] & 0x3e)>>1)];
	result[13] = base32[((str[7] & 0x01)<<4) + ((str[8] & 0xf0)>>4)];
	result[14] = base32[((str[8] & 0x0f)<<1) + ((str[9] & 0x80)>>7)];
	result[15] = base32[((str[9] & 0x7c)>>2)];
	result[16] = base32[((str[9] & 0x03)<<3) + ((str[10] & 0xe0)>>5)];
	result[17] = base32[((str[10] & 0x1f))];
	result[18] = base32[((str[11] & 0xf8)>>3)];
	result[19] = base32[((str[11] & 0x07)<<2) + ((str[12] & 0xc0)>>6)];
	result[20] = base32[((str[12] & 0x3e)>>1)];
	result[21] = base32[((str[12] & 0x01)<<4) + ((str[13] & 0xf0)>>4)];
	result[22] = base32[((str[13] & 0x0f)<<1) + ((str[14] & 0x80)>>7)];
	result[23] = base32[((str[14] & 0x7c)>>2)];
	result[24] = base32[((str[14] & 0x03)<<3) + ((str[15] & 0xe0)>>5)];
	result[25] = base32[((str[15] & 0x1f))];
	

	return newSVpv(result, RESULT_LEN);
}

SV* build_binary_ulid (double time, SV *randomnesssv)
{
	unsigned long len;
	char *randomness = SvPVbyte(randomnesssv, len);
	if (len == 0) croak("no randomness was fetched for build_binary_ulid");

	char result[ULID_LEN] = "\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0\0";
	int i, j;

	unsigned long long microtime = time * 1000;

	// network byte order
	for (i = ULID_TIME_LEN - 1; i >= 0; --i) {
		result[i] = (char) (microtime & 0xff);
		microtime = microtime >> 8;
	}

	for (i = ULID_LEN - len, j = 0; i < ULID_LEN; ++i) {
		result[i] = randomness[j++];
	}

	return newSVpv(result, ULID_LEN);
}

// proper XS Code starts here

#line 94 "XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 238 "XS.c"

XS_EUPXS(XS_Data__ULID__XS_ulid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__ULID__XS_ulid)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	SV *	RETVAL;
#line 91 "XS.xs"
		dSP;

		PUSHMARK(SP);

		if (items == 0) {
			int count = call_pv("Data::ULID::XS::binary_ulid", G_SCALAR);

			SPAGAIN;

			if (count != 1) {
				croak("Calling Data::ULID::XS::binary_ulid went wrong in Data::ULID::XS::ulid");
			}

			RETVAL = encode_ulid(POPs);
		}
		else {
			EXTEND(SP, 1);
			PUSHs(ST(0));
			PUTBACK;

			int count = call_pv("Data::ULID::ulid", G_SCALAR);

			SPAGAIN;

			if (count != 1) {
				croak("Calling Data::ULID::ulid went wrong in Data::ULID::XS::ulid");
			}

			SV *ret = POPs;
			SvREFCNT_inc(ret);
			RETVAL = ret;
		}

		PUTBACK;
#line 283 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Data__ULID__XS_binary_ulid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Data__ULID__XS_binary_ulid)
{
    dVAR; dXSARGS;
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    {
	SV *	RETVAL;
#line 131 "XS.xs"
		dSP;

		PUSHMARK(SP);

		if (items == 0) {
			SV *tmp = newSViv(10);

			EXTEND(SP, 2);
			PUSHs(get_sv("Data::ULID::XS::RNG", 0));
			PUSHs(tmp);
			PUTBACK;

			int count = call_method("bytes", G_SCALAR);
			SvREFCNT_dec(tmp);

			SPAGAIN;

			if (count != 1) {
				croak("Calling method bytes on Crypt::PRNG::* went wrong in Data::ULID::XS::binary_ulid");
			}

			SV **svp = hv_fetchs(PL_modglobal, "Time::NVtime", 0);
			if (!SvIOK(*svp)) croak("Time::NVtime isn't a function pointer");
			NV (*nvtime)() = INT2PTR(NV(*)(), SvIV(*svp));

			RETVAL = build_binary_ulid((*nvtime)(), POPs);
		}
		else {
			EXTEND(SP, 1);
			PUSHs(ST(0));
			PUTBACK;

			int count = call_pv("Data::ULID::binary_ulid", G_SCALAR);

			SPAGAIN;

			if (count != 1) {
				croak("Calling Data::ULID::binary_ulid went wrong in Data::ULID::XS::binary_ulid");
			}

			SV *ret = POPs;
			SvREFCNT_inc(ret);
			RETVAL = ret;
		}

		PUTBACK;
#line 346 "XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}

#ifdef __cplusplus
extern "C" {
#endif
XS_EXTERNAL(boot_Data__ULID__XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Data__ULID__XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        newXS_deffile("Data::ULID::XS::ulid", XS_Data__ULID__XS_ulid);
        newXS_deffile("Data::ULID::XS::binary_ulid", XS_Data__ULID__XS_binary_ulid);
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

#ifdef __cplusplus
}
#endif
